#ifndef NCUTEXCEPTION_H
#define NCUTEXCEPTION_H 1

#include <iostream>
#include <exception>

namespace ncut
{

class ncutException: public std::exception
{
  public:

    ncutException() throw();
    ncutException(const char* errmsg) throw();

    ncutException(const ncutException& clone) throw();

    virtual ~ncutException() throw();

    virtual const char* what() const throw();

    virtual ncutException& operator=(const ncutException&) throw();

  protected:

    const char* errmsg_;
};

class ncutCritical: public ncutException
{
  public:

    ncutCritical() throw();
    ncutCritical(const char* errmsg) throw();

    virtual ~ncutCritical() throw();

//     virtual ncutException& operator=(const ncutException&) throw();

};

} // namespace ncut

#endif // NCUTEXCEPTION_H
